# Puissance 4

<a name="readme-top"></a>

<details>
  <summary>Table des matières</summary>
  <ol>
    <li><a href="#resume">Résumé</a></li>
    <li><a href="#prerequis">Prérequis</a></li>
    <li><a href="#installation">Installation</a></li>
    <li><a href="#utilisation">Utilisation</a></li>
    <li><a href="#contribution">Contribuer</a></li>
    <li><a href="#fonctionnalites">Fonctionnalités</a></li>
    <li><a href="#docs">Docs</a></li>
    <li><a href="#licence">Licence</a></li>
  </ol>
</details>

## Résumé

Il s'agit d'une implémentation en terminal du jeu **Puissance 4**, où deux joueurs peuvent s'affronter sur une grille pour aligner quatre pièces horizontalement, verticalement ou diagonalement. Le jeu propose trois modes :

- **Mode 1** : Jeu en solo contre une IA aléatoire.
- **Mode 2** : Jeu en solo contre une IA intelligente.
- **Mode 3** : Jeu à deux joueurs (humain contre humain).

Le jeu est affiché à l'aide de l'ASCII art dans le terminal.

## Prérequis

Avant de lancer l'application, vous devez avoir les éléments suivants installés :

- Un compilateur C (GCC)
- Make (pour construire le projet)

Assurez-vous que ces outils sont disponibles sur votre système.

## Installation

Pour installer et lancer le jeu, suivez ces étapes :

1. Clonez le dépôt sur votre machine locale :

   ```sh
   git clone https://gitedu.hesge.ch/anthony.bouillan/puissance4
   cd puissance4
   ```

2. Compilez le projet :

   ```sh
   make
   ```

3. Exécutez le jeu :

   ```sh
   ./puissance4
   ```

   Le jeu s'affichera dans votre terminal.

## Utilisation

Lorsque vous lancez le jeu, vous serez invité à choisir un mode de jeu et à commencer à jouer. Vous devrez entrer les colonnes où vous souhaitez placer vos pions.

## Contribuer

Les contributions sont les bienvenues ! Voici comment vous pouvez contribuer au projet :

1. Forkez le projet
2. Créez votre branche de fonctionnalité (`git checkout -b fonctionnalite/nom-de-la-fonctionnalite`)
3. Commitez vos modifications (`git commit -m 'Ajout de la fonctionnalité nom-de-la-fonctionnalite'`)
4. Poussez votre branche (`git push origin fonctionnalite/nom-de-la-fonctionnalite`)
5. Ouvrez une Pull Request

## Fonctionnalités

### Mode solo contre IA aléatoire

Affrontez une IA qui place ses pions de manière aléatoire.

### Mode solo contre IA intelligente

Affrontez une IA qui utilise une logique de jeu plus avancée pour décider de ses mouvements.

### Mode à deux joueurs

Jouez à Puissance 4 avec un autre joueur sur le même appareil.

### Affichage ASCII

Le jeu est affiché dans le terminal à l'aide d'ASCII art, offrant une expérience simple et agréable.

## Docs

Le dossier **docs** contient un petit fichier d'analyse, ainsi que le cahier des charges du projet.

## Commandes Make disponibles

Voici les commandes `make` disponibles dans le projet :

- **`make`** ou **`make puissance4`** : Compile le jeu.
- **`make test_puissance4`** : Compile les tests unitaires pour le projet.
- **`make clean`** : Supprime les fichiers générés (binaires, objets, etc.).
- **`make run`** : Lance le jeu avec des paramètres spécifiques (ex. `./puissance4 3 5 6`).
- **`make run_unit_tests`** : Exécute les tests unitaires.
- **`make tests`** : Compile et lance uniquement les testbeds.
- **`make run_all_tests`** : Exécute les tests unitaires et les testbeds.

## Licence

Ce projet est sous licence MIT. Voir le fichier [LICENSE](LICENSE) pour plus de détails.
