#include "board.h"

void fill_board(int rows, int cols, int** board) {
    for (int i = 0; i < rows; i++) {
        for (int j = 0; j < cols; j++) {
            board[i][j] = EMPTY;
        }
    }
}

int destroy_board(int rows, int** board) {
    for (int i = 0; i < rows; i++) {
        free(board[i]);
    }
    free(board);
    return EXIT_SUCCESS;
}

void print_board(int rows, int cols, int** board) {
    for (int row = -1; row <= rows; row++) {
        if (row == -1) {
            printf("\n┌");
        } else if (row == rows) {
            printf("└");
        } else {
            printf("│");
        }

        for (int col = 0; col < cols; col++) {
            if (row == -1 || row == rows) {
                printf("─");
            } else {
                printf("%c", transform_state_to_char(board[row][col]));
            }

            if (col < cols - 1) {
                if (row == -1) {
                    printf("┬");
                } else if (row == rows) {
                    printf("┴");
                } else {
                    printf("│");
                }
            }
        }

        if (row == -1) {
            printf("┐\n");
        } else if (row == rows) {
            printf("┘\n");
        } else {
            printf("│\n");
            if (row < rows - 1) {
                printf("├");
                for (int col = 0; col < cols; col++) {
                    printf("─");
                    if (col < cols - 1) {
                        printf("┼");
                    }
                }
                printf("┤\n");
            }
        }
    }

    for (int i = 1; i < cols + 1; i++) {
        printf(" %d", i);
    }
}

int** create_board(int rows, int cols) {
    int** board = malloc(rows * sizeof(int*));
    if (board == NULL) {
        return NULL;
    }
    for (int i = 0; i < rows; i++) {
        board[i] = malloc(cols * sizeof(int));
        if (board[i] == NULL) {
            for (int j = 0; j < i; j++) {
                free(board[j]);
            }
            free(board);
            return NULL;
        }
    }
    return board;
}

char transform_state_to_char(enum BOARD_STATE state) {
    switch (state) {
    case PLAYER1:
        return 'X';
        break;
    case PLAYER2:
        return 'O';
        break;
    default:
        return ' ';
        break;
    }
}