#include "test_board.h"

void test_destroy_board() {
    int rows = 6;
    int cols = 7;
    int** board = create_board(rows, cols);
    if (board == NULL) {
        fprintf(stderr, "test_destroy_board: FAILED\n");
        exit(EXIT_FAILURE);
    }

    fill_board(rows, cols, board);
    assert(destroy_board(rows, board) == EXIT_SUCCESS && "test_destroy_board: FAILED\n");
    PRINT_SUCCESS("test_destroy_board: PASSED");
}

void test_create_board() {
    int rows = 6;
    int cols = 7;
    int** board = create_board(rows, cols);
    assert(board != NULL && "Board creation failed\n");

    for (int i = 0; i < rows; i++) {
        assert(board[i] != NULL && "Row allocation failed\n");
    }

    destroy_board(rows, board);
    PRINT_SUCCESS("test_create_board: PASSED");
}

void test_fill_board() {
    int rows = 6;
    int cols = 7;
    int** board = create_board(rows, cols);
    assert(board != NULL && "Board creation failed\n");

    fill_board(rows, cols, board);

    for (int i = 0; i < rows; i++) {
        for (int j = 0; j < cols; j++) {
            assert(board[i][j] == EMPTY && "test_fill_board: FAILED at board[%d][%d]\n");
        }
    }

    destroy_board(rows, board);
    PRINT_SUCCESS("test_fill_board: PASSED");
}
