
#include "computer.h"

int select_smart_column(int number_of_columns, int number_of_rows, int** board) {
    int robot_selected_column = -999;

    // 1. Check if the AI can win in the next move, if so, play it
    for (int col = 0; col < number_of_columns; col++) {
        if (!is_column_full(col, number_of_rows, board)) {
            struct coordinate temp_coordinate = find_empty_slot(col, number_of_rows, board);

            board[temp_coordinate.x][temp_coordinate.y] = PLAYER2;
            if (does_player_win(temp_coordinate, number_of_rows, number_of_columns, board)) {
                robot_selected_column = col;
                board[temp_coordinate.x][temp_coordinate.y] = EMPTY;
                break;
            }
            board[temp_coordinate.x][temp_coordinate.y] = EMPTY;
        }

    }

    if (robot_selected_column != -999) {
        return robot_selected_column;
    }

    // 2. Check if the player can win in the next move, if so, block it
    for (int col = 0; col < number_of_columns; col++) {
        if (!is_column_full(col, number_of_rows, board)) {
            struct coordinate temp_coordinate = find_empty_slot(col, number_of_rows, board);

            // Check if the player can win in the next move
            board[temp_coordinate.x][temp_coordinate.y] = PLAYER1;
            if (does_player_win(temp_coordinate, number_of_rows, number_of_columns, board)) {
                robot_selected_column = col;
                board[temp_coordinate.x][temp_coordinate.y] = EMPTY;
                break;
            }
            board[temp_coordinate.x][temp_coordinate.y] = EMPTY;
        }
    }

    // 3. If no winning move is found, select a random column
    if (robot_selected_column == -999) {
        robot_selected_column = select_random_column(number_of_columns, number_of_rows, board);
    }

    return robot_selected_column;
}

int select_random_column(int number_of_columns, int number_of_rows, int** board) {
    int robot_selected_column = -999;
    do {
        robot_selected_column = rand() % number_of_columns;
    } while (is_column_full(robot_selected_column, number_of_rows, board));

    return robot_selected_column;
}

bool is_column_full(int col, int rows, int** board) {
    for (int i = 0; i < rows; i++) {
        if (board[i][col] == EMPTY) {
            return false;
        }
    }
    return true;
}