#include "test_puissance4.h"

int main() {
    // game.h
    test_create_board();
    test_fill_board();
    test_destroy_board();

    // computer.h
    test_is_column_full();
    test_select_smart_column();
    test_select_random_column();

    // board.h
    test_place_token();
    test_find_empty_slot();
    test_is_valid_column();
    test_is_board_full();
    test_does_player_win();

    return EXIT_SUCCESS;
}

int** setup_board(int rows, int cols) {
    int** board = create_board(rows, cols);
    if (board == NULL) {
        fprintf(stderr, "Error: Unable to allocate memory for the board.\n");
        exit(EXIT_FAILURE);
    }
    fill_board(rows, cols, board);

    return board;
}

void reset_board(int rows, int cols, int** board) {
    for (int i = 0; i < rows; i++) {
        for (int j = 0; j < cols; j++) {
            board[i][j] = EMPTY;
        }
    }
}
